// ChatServer.h

#ifndef CHATSERVER_H
#define CHATSERVER_H

#include <QtNetwork>
#include <QString>
#include <QThread>
#include <QApplication>
#include <vector>
using namespace std;

class ChatServer;
class ClientHandler : public QObject
{
  Q_OBJECT
private:
  QString ch_name; 
  QTcpSocket* ch_socket;
  QTextStream* ch_os;
public:
  ClientHandler( QTcpSocket* sock);
  virtual ~ClientHandler();
  static ChatServer * ch_server;
private slots:
  void readFromClient();
  friend class ChatServer;
};


class ChatServer: public QObject 
{
  Q_OBJECT
private:
  QTcpServer * cs_server;
  QList<ClientHandler *> cs_clientList;
public:
  ChatServer( );
  virtual ~ChatServer();
  void broadcastClient(QString);
public slots:
  void connectNewClient( );
};
#endif
