//ClientSocket.cc

#include "ClientSocket.h"
#include <string>
#include <iostream>
using namespace std;


ClientSocket::ClientSocket( string siteName ) 
{
  wwwName = siteName;
  socket = new QTcpSocket( );
  connect( socket, SIGNAL( connected() ),
	   this,   SLOT( reportConnected() ) );
  connect( socket, SIGNAL( hostFound() ),
	   this,   SLOT( reportHostFound() ) );
  connect( socket, SIGNAL( readyRead() ),
	   this,   SLOT( getWebPage() ) );
  connect( socket, SIGNAL( connectionClosed() ),
	   this,   SLOT( socketConnectionClosed() ) );
  QString qstr( wwwName.c_str() );
  socket->connectToHost( qstr, 80 );  
}

ClientSocket::~ClientSocket() {
  if (socket) {
    delete socket; 
  }
}

string ClientSocket::constructHttpRequest( ) {
  string hostHeader = "Host: " + wwwName;
  string urlString( hostHeader );
  string httpRequestString = "GET / HTTP/1.0\r\n" + 
    urlString + "\r\n" + "\r\n";
  return httpRequestString;
}

void ClientSocket::reportHostFound() {
  // cout << "host found" << endl; 
}

void ClientSocket::reportConnected() {
  // cout << "connection established" << endl; 
  string httpRequest = constructHttpRequest();
  socket->write( httpRequest.c_str() );
}

void ClientSocket::getWebPage() {
  // cout << "socket ready to read" << endl; 
  int howManyBytes = socket->bytesAvailable();
  // cout << "bytes available: " << howManyBytes << endl;
  char data[howManyBytes];
  socket->read( data, howManyBytes );
  cout << data;
  cout.flush();
}

void ClientSocket::socketConnectionClosed() {
  // cout << "socketConnectionClosed" << endl;
  exit(0);
}

int main( int argc, char* argv[] )
{
  if (argc > 1) 
    { 
      QApplication app( argc, argv );
      ClientSocket sock( argv[1] ); 
      return app.exec();
    }
  return 0;
}
