#ifndef PRIMESERVER_H
#define PRIMESERVER_H

#include <QtNetwork>
#include <QString>
#include <QThread>
#include <QApplication>
#include <vector>
using namespace std;

class PrimeServer;
class ClientHandler : public QObject
{
  Q_OBJECT
private:
  QTcpSocket* ch_socket;
  QTextStream* ch_os;
public:
  ClientHandler( QTcpSocket* sock);
  virtual ~ClientHandler();
private slots:
  void readFromClient();
  friend class PrimeServer;
};


class PrimeServer: public QObject 
{
  Q_OBJECT
private:
  QTcpServer * cs_server;
  QList<ClientHandler *> cs_clientList;
public:
  PrimeServer( );
  virtual ~PrimeServer();
public slots:
  void connectNewClient( );
};
#endif
